<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="DoxyPress 1.2.10"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Commanders: D:/Mes documents/Trusty/Arduino/Libraries/Commanders/src/ButtonsCommanderPush.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="doxypress.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by DoxyPress -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Commanders
   </div>
   <div id="projectbrief">Arduino buttons/bus library</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by DoxyPress 1.2.10 -->
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('ButtonsCommanderPush_8hpp_source.html','');});
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">ButtonsCommanderPush.hpp</div>  </div>
  <div class="clear-floats"></div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">//-------------------------------------------------------------------</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#ifndef __buttonsCommanderPush_H__</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#define __buttonsCommanderPush_H__</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">//-------------------------------------------------------------------</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;</div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="Commanders_8h.html">Commanders.h</a>&gt;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#ifndef NO_BUTTONSCOMMANDER</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef NO_BUTTONSCOMMANDERPUSH</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &quot;Chain.hpp&quot;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;</div><div class="line"><a name="l00012"></a><span class="lineno"><a class="line" href="structEvent.html">   12</a></span>&#160;<span class="keyword">struct </span><a class="code" href="structEvent.html">Event</a></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;{</div><div class="line"><a name="l00014"></a><span class="lineno"><a class="line" href="structEvent.html#afd30660358c854e191265792814ee078">   14</a></span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="structEvent.html#afd30660358c854e191265792814ee078">Id</a>; </div><div class="line"><a name="l00015"></a><span class="lineno"><a class="line" href="structEvent.html#a30e11257e8ec1f970fb3159060bc2d17">   15</a></span>&#160;    <a class="code" href="Events_8h.html#a36239a7eea6194f04e73e80d7419490c">COMMANDERS_EVENT_TYPE</a> <a class="code" href="structEvent.html#a30e11257e8ec1f970fb3159060bc2d17">EventType</a>; </div><div class="line"><a name="l00016"></a><span class="lineno"><a class="line" href="structEvent.html#add1010c7a7dfb056fee72df7c1575d90">   16</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="structEvent.html#add1010c7a7dfb056fee72df7c1575d90">Data</a>; </div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;};</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00029"></a><span class="lineno"><a class="line" href="classButtonsCommanderPush.html">   29</a></span>&#160;<span class="keyword">class </span><a class="code" href="classButtonsCommanderPush.html">ButtonsCommanderPush</a> : <span class="keyword">public</span> <a class="code" href="classButtonsCommanderButton.html">ButtonsCommanderButton</a></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;{</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160; <span class="keyword">private</span>:</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    GPIO_pin_t buttonPin;   <span class="comment">// the number of the pushbutton pin</span></div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    byte lastButtonState;   <span class="comment">// the previous reading from the input pin</span></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> lastDebounceTime;  <span class="comment">// the last time the output pin was toggled</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> debounceDelay;    <span class="comment">// the debounce time; increase if the output flickers</span></div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    </div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <a class="code" href="classCMDRSCHAINEDLIST.html">CMDRSCHAINEDLIST&lt;Event&gt;</a> Events;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160; <span class="keyword">public</span>:</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    <a class="code" href="classButtonsCommanderPush.html#ae5e721c350254591d3bd00b9f9e9de1b">ButtonsCommanderPush</a>();</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classButtonsCommanderPush.html#ab8fb73b9998dc9fa58cfd1b26080ef1a">begin</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId, <span class="keywordtype">int</span> inButtonPin, <a class="code" href="Events_8h.html#a36239a7eea6194f04e73e80d7419490c">COMMANDERS_EVENT_TYPE</a> inEventType = <a class="code" href="Events_8h.html#a36239a7eea6194f04e73e80d7419490ca4c6e59b277bf1f4430a136faab150a61">COMMANDERS_EVENT_MOVEPOSITIONID</a>, <span class="keywordtype">int</span> inData = 0);</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classButtonsCommanderPush.html#afba3fe21579365395bc41a5d3f87b207">AddEvent</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId, <a class="code" href="Events_8h.html#a36239a7eea6194f04e73e80d7419490c">COMMANDERS_EVENT_TYPE</a> inEventType = <a class="code" href="Events_8h.html#a36239a7eea6194f04e73e80d7419490ca4c6e59b277bf1f4430a136faab150a61">COMMANDERS_EVENT_MOVEPOSITIONID</a>, <span class="keywordtype">int</span> inData = 0);</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classButtonsCommanderPush.html#a7b1af7744bd5bafaf42e355cb5a0a7dd">loop</a>();</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;</div><div class="line"><a name="l00066"></a><span class="lineno"><a class="line" href="classButtonsCommanderPush.html#ad4a86075facec25cb45e703971c4e7c0">   66</a></span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">int</span> <a class="code" href="classButtonsCommanderPush.html#ad4a86075facec25cb45e703971c4e7c0">GetPin</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> GPIO_to_Arduino_pin(this-&gt;buttonPin); }</div><div class="line"><a name="l00070"></a><span class="lineno"><a class="line" href="classButtonsCommanderPush.html#ae3148a0249bfbec51d2fcc906e2a9603">   70</a></span>&#160;    <span class="keyword">inline</span> GPIO_pin_t <a class="code" href="classButtonsCommanderPush.html#ae3148a0249bfbec51d2fcc906e2a9603">GetDIO2Pin</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> this-&gt;buttonPin; }</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    </div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;<span class="preprocessor">#ifdef COMMANDERS_PRINT_COMMANDERS</span></div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    <span class="keywordtype">void</span> printCommander();</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;};</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;<span class="comment">//-------------------------------------------------------------------</span></div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="classButtonsCommanderPush_html_ae3148a0249bfbec51d2fcc906e2a9603"><div class="ttname"><a href="classButtonsCommanderPush.html#ae3148a0249bfbec51d2fcc906e2a9603">ButtonsCommanderPush::GetDIO2Pin</a></div><div class="ttdeci">GPIO_pin_t GetDIO2Pin() const </div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderPush_8hpp_source.html#l00070">ButtonsCommanderPush.hpp:70</a></div></div>
<div class="ttc" id="classButtonsCommanderPush_html_ad4a86075facec25cb45e703971c4e7c0"><div class="ttname"><a href="classButtonsCommanderPush.html#ad4a86075facec25cb45e703971c4e7c0">ButtonsCommanderPush::GetPin</a></div><div class="ttdeci">int GetPin() const </div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderPush_8hpp_source.html#l00066">ButtonsCommanderPush.hpp:66</a></div></div>
<div class="ttc" id="classButtonsCommanderPush_html_a7b1af7744bd5bafaf42e355cb5a0a7dd"><div class="ttname"><a href="classButtonsCommanderPush.html#a7b1af7744bd5bafaf42e355cb5a0a7dd">ButtonsCommanderPush::loop</a></div><div class="ttdeci">unsigned long loop()</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderPush_8cpp_source.html#l00040">ButtonsCommanderPush.cpp:40</a></div></div>
<div class="ttc" id="classButtonsCommanderPush_html_afba3fe21579365395bc41a5d3f87b207"><div class="ttname"><a href="classButtonsCommanderPush.html#afba3fe21579365395bc41a5d3f87b207">ButtonsCommanderPush::AddEvent</a></div><div class="ttdeci">void AddEvent(unsigned long inId, COMMANDERS_EVENT_TYPE inEventType = COMMANDERS_EVENT_MOVEPOSITIONID, int inData = 0)</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderPush_8cpp_source.html#l00031">ButtonsCommanderPush.cpp:31</a></div></div>
<div class="ttc" id="Events_8h_html_a36239a7eea6194f04e73e80d7419490ca4c6e59b277bf1f4430a136faab150a61"><div class="ttname"><a href="Events_8h.html#a36239a7eea6194f04e73e80d7419490ca4c6e59b277bf1f4430a136faab150a61">COMMANDERS_EVENT_MOVEPOSITIONID</a></div><div class="ttdef"><b>Definition:</b> <a href="Events_8h_source.html#l00032">Events.h:32</a></div></div>
<div class="ttc" id="classButtonsCommanderPush_html_ab8fb73b9998dc9fa58cfd1b26080ef1a"><div class="ttname"><a href="classButtonsCommanderPush.html#ab8fb73b9998dc9fa58cfd1b26080ef1a">ButtonsCommanderPush::begin</a></div><div class="ttdeci">void begin(unsigned long inId, int inButtonPin, COMMANDERS_EVENT_TYPE inEventType = COMMANDERS_EVENT_MOVEPOSITIONID, int inData = 0)</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderPush_8cpp_source.html#l00019">ButtonsCommanderPush.cpp:19</a></div></div>
<div class="ttc" id="classButtonsCommanderPush_html_ae5e721c350254591d3bd00b9f9e9de1b"><div class="ttname"><a href="classButtonsCommanderPush.html#ae5e721c350254591d3bd00b9f9e9de1b">ButtonsCommanderPush::ButtonsCommanderPush</a></div><div class="ttdeci">ButtonsCommanderPush()</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderPush_8cpp_source.html#l00011">ButtonsCommanderPush.cpp:11</a></div></div>
<div class="ttc" id="classCMDRSCHAINEDLIST_html"><div class="ttname"><a href="classCMDRSCHAINEDLIST.html">CMDRSCHAINEDLIST&lt; Event &gt;</a></div></div>
<div class="ttc" id="classButtonsCommanderButton_html"><div class="ttname"><a href="classButtonsCommanderButton.html">ButtonsCommanderButton</a></div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderButton_8hpp_source.html#l00015">ButtonsCommanderButton.hpp:15</a></div></div>
<div class="ttc" id="classButtonsCommanderPush_html"><div class="ttname"><a href="classButtonsCommanderPush.html">ButtonsCommanderPush</a></div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderPush_8hpp_source.html#l00029">ButtonsCommanderPush.hpp:29</a></div></div>
<div class="ttc" id="structEvent_html_a30e11257e8ec1f970fb3159060bc2d17"><div class="ttname"><a href="structEvent.html#a30e11257e8ec1f970fb3159060bc2d17">Event::EventType</a></div><div class="ttdeci">COMMANDERS_EVENT_TYPE EventType</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderPush_8hpp_source.html#l00015">ButtonsCommanderPush.hpp:15</a></div></div>
<div class="ttc" id="Events_8h_html_a36239a7eea6194f04e73e80d7419490c"><div class="ttname"><a href="Events_8h.html#a36239a7eea6194f04e73e80d7419490c">COMMANDERS_EVENT_TYPE</a></div><div class="ttdeci">COMMANDERS_EVENT_TYPE</div><div class="ttdef"><b>Definition:</b> <a href="Events_8h_source.html#l00025">Events.h:25</a></div></div>
<div class="ttc" id="structEvent_html_afd30660358c854e191265792814ee078"><div class="ttname"><a href="structEvent.html#afd30660358c854e191265792814ee078">Event::Id</a></div><div class="ttdeci">unsigned long Id</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderPush_8hpp_source.html#l00014">ButtonsCommanderPush.hpp:14</a></div></div>
<div class="ttc" id="structEvent_html_add1010c7a7dfb056fee72df7c1575d90"><div class="ttname"><a href="structEvent.html#add1010c7a7dfb056fee72df7c1575d90">Event::Data</a></div><div class="ttdeci">int Data</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderPush_8hpp_source.html#l00016">ButtonsCommanderPush.hpp:16</a></div></div>
<div class="ttc" id="structEvent_html"><div class="ttname"><a href="structEvent.html">Event</a></div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderPush_8hpp_source.html#l00012">ButtonsCommanderPush.hpp:12</a></div></div>
<div class="ttc" id="Commanders_8h_html"><div class="ttname"><a href="Commanders_8h.html">Commanders.h</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- Generated by DoxyPress 1.2.10 -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_d41d8cd98f00b204e9800998ecf8427e.html">src</a></li><li class="navelem"><b>ButtonsCommanderPush.hpp</b></li>
    <li class="footer">Generated on mer. oct. 18 2017 17:55:02 for Commanders &nbsp; by
    <a href="http://www.copperspice.com/documentation-doxypress.html">
    <img class="footer" src="doxypress.png" alt="DoxyPress"/></a> 1.2.10 </li>
  </ul>
</div>
</body>
</html>
